<?php
/**
 * Clase Base FN para BaseCrCategoriaPrestamologFN
 *
 * @package    
 * @subpackage BaseCrCategoriaPrestamologFN
 * @author     Willy
 * @version    SVN:: BaseCrCategoriaPrestamologFN.class.php,v 1.1 2017-09-02 12:04:51 william.taype Exp $
 */
class BaseCrCategoriaPrestamologFN extends CrCategoriaPrestamologBN
{
  private static $fieldNames = array (
    'Idprestamo'=>'idprestamo', 'Fecha'=>'fecha', 'Nombrecategoria'=>'nombrecategoria', 'Idcategoria'=>'idcategoria', 'Peso'=>'peso'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idprestamo, fecha, nombrecategoria, idcategoria, peso FROM cr_categoria_prestamolog WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
      echo $sql;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idprestamo, fecha, nombrecategoria, idcategoria, peso FROM cr_categoria_prestamolog WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdprestamo()){ $where .= " AND idprestamo = '".$this->getIdprestamo()."'"; }
      if($this->getFecha()){ $where .= " AND fecha = '".$this->getFecha()."'"; }
      if($this->getNombrecategoria()){ $where .= " AND nombrecategoria = '".$this->getNombrecategoria()."'"; }
      if($this->getIdcategoria()){ $where .= " AND idcategoria = '".$this->getIdcategoria()."'"; }
      if($this->getPeso()){ $where .= " AND peso = '".$this->getPeso()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idprestamo, fecha, nombrecategoria, idcategoria, peso FROM cr_categoria_prestamolog WHERE 1 AND idprestamo='".$this->getIdprestamo()."' AND fecha='".$this->getFecha()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrCategoriaPrestamologFN = new BaseCrCategoriaPrestamologFN();
    $o_BaseCrCategoriaPrestamologFN->setIdprestamo($o_propel->idprestamo);
    $o_BaseCrCategoriaPrestamologFN->setFecha($o_propel->fecha);
    $o_BaseCrCategoriaPrestamologFN->setNombrecategoria($o_propel->nombrecategoria);
    $o_BaseCrCategoriaPrestamologFN->setIdcategoria($o_propel->idcategoria);
    $o_BaseCrCategoriaPrestamologFN->setPeso($o_propel->peso);
    return $o_BaseCrCategoriaPrestamologFN;
  }
}